Needs["Statistics`NormalDistribution`"]

nor[mu_, sig_]:= Random[NormalDistribution[mu, sig]];

MCEuropean[s_, n_, sigma_, T_, Rf_, exercise_Function]:= 
Module[{m = N[Log[s] + (Rf - 1/2 sigma^2) T],
	sg = N[sigma Sqrt[T]], tbl},
  tbl = Table[nor[m, sg], {i, n}];
  Exp[-Rf T] Map[exercise, Exp[Join[tbl, 2m - tbl]]] //
    {Mean[#], StandardErrorOfSampleMean[#]}& ]
    
MCEuropeanCall[k_, s_, n_, sigma_, T_, Rf_]:= 
  MCEuropean[s, n, sigma, T, Rf, Max[# - k, 0]&]

cnorm[x_]:= N[CDF[NormalDistribution[0, 1], x]];

BSCall[k_, s_, sigma_, T_, Rf_]:=
Module[{d1 = (Log[s/k] + T (Rf + sigma^2/2))/(sigma Sqrt[T])},
  N[s cnorm[d1] - k Exp[-Rf T] cnorm[d1-sigma Sqrt[T]]]];

paths[s_, sigma_, T1_, T_, Rf_, n_, navg_]:=
Module[{mdist = Log[s] + (Rf - sigma^2/2) T1,
	sdist = sigma Sqrt[T1], mpath = 1 + Rf (T - T1)/(navg - 1),
	spath = sigma Sqrt[(T - T1)/(navg - 1)]},
  Table[NestList[# nor[mpath, spath]&, Exp[nor[mdist, sdist]], navg - 1], 
	{i, n}] ]

MCAsianCall[s_, sigma_, T1_, T_, Rf_, n_, navg_]:=
  (Exp[-T Rf] * Map[Max[0, Mean[#] - k]&, 
        paths[s, sigma, T1, T, Rf, n, navg]]) //
   {Mean[#], StandardErrorOfSampleMean[#]}& 

MCAsianCall2[k_, s_, sigma_, T1_, T_, Rf_, n_, navg_]:=
Module[{path = paths[s, sigma, T1, T, Rf, n, navg], sample, call},  
  sample = Exp[-T Rf] Map[Max[0, Mean[#] - k]&, path];
  call = Mean[sample];
  {call, StandardErrorOfSampleMean[sample],
    call + BSCall[k, s, sigma, T1, Rf] -
      Exp[-Rf T1] *
        Mean[Map[Max[0, # - k]&, Map[First, path]]]} ]
