(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, O486, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, O486, bold, e6,  18, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, O486, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, O486, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, O486, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, O486, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, O486, bold, L-3,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, O486, L-3,  10, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, O486, R32768, L-3,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, O486, L-3,  10, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, O486, B32768, L-3,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, O486, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = leftheader, inactive, O486, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7, O486,  12, "Times"; 
	fontset = leftfooter, inactive, O486, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, O486,  12, "Times"; 
	paletteColors = 128; showRuler; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
Simple Merger.m Demo
:[font = section; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 Introduction
:[font = text; inactive; preserveAspect; endGroup]
This notebook illustrates the "top" level functions in the merger.m package.  The easiest way to use the package is to make a copy of this notebook, and then modify it for your own use.
:[font = section; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 Turn off some Mathematica warning messages,
  and load the package
;[s]
3:0,0;15,1;26,0;68,-1;
2:2,19,14,Times,1,18,0,0,0;1,19,14,Times,3,18,0,0,0;
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468]
Off[General::spell];
Off[General::spell1];
Off[Set::write];
Off[Power::infy];
Off[Infinity::indet];
Off[Solve::dinv];
Off[NumberForm::sigz];
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468]
<<froeb`merger`merger`
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
?Merger
:[font = print; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; endGroup; endGroup]
This package defines functions used to simulate mergers in
   differentiated and homogenous product industries.  Available
   functions:  ChoiceProbabilities, DemandConstants, MarginalCosts,
   PostMerger, PrintResults, DiffProdMerger, DiffProdMergerMinCost,
   HomoProdMerger, PostMergerC.
:[font = section; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 Bertrand Simulation Inputs
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468]
firmData={
          FirmNames={"NTT","DDI","Telecom","Teleway",
                     "No Purchase"},
          p0={1.,.9,.9,.9,0},
          q0={.865,.088,.043,.004,0}
         };   
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; endGroup]
demandData={b=9.557,e=.62};   
:[font = section; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 Differentiated Products Simulation
:[font = subsection; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 no merger synergies
:[font = input; preserveAspect; startGroup]
?DiffProdMerger
:[font = print; inactive; preserveAspect; endGroup]
DiffProdMerger[merging_List, (nested_List), (nestParam_),
   {b,elasticity}, {FirmNames,p0,q0}] This function calls all the
   other functions to calculate the effects of a merger in a
   differentiated product industry.  Merging is a list of the
   merging firms, e.g., {1,2,3}; nested is a list of the products
   in the demand nest, e.g., {2,3,4}; nestParam is a value between
   0 and 1 that controls the strength of the nest--1 is a flat
   logit, and 0 is a strong nest; b is an estimated cross
   elasticity of demand parameter from the logit model; p0 is the
   vector of pre-merger prices; q0 is the vector of pre-merger
   quantities or market shares; elasticity is the pre-merger
   aggregate elasticity for the inside goods; FirmNames is a vector
   of firm names.  Note that the last choice is the 'no purchase'
   option or 'outside' good with a pre-merger price and quantity of
   zero.
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
DiffProdMerger[merging={2,3,4},nest={2,3,4},nestParam=.9,demandData,firmData]
:[font = output; output; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; fontLeading = 0; endGroup; endGroup]
TableForm[{"DIFFERENTIATED PRODUCTS MERGER SIMULATION RESULTS"
           "Elasticity = 0.62"
           "B = 9.557"
           "Nest Parameter = 0.9"
           "@ signifies nest member"
           "* signifies merging firms"
           "Changes in profits and welfare are expressed as a % of\
            
             pre-merger revenue."
 
    , NumberForm[TableForm[{{"Firms", "a", "q0", "q1", "% change\
 
        q"}, {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway", "  No\
 
         Purchase"}, {22.06566821441421, 18.86736931835656, 
 
        18.22284628945038, 16.08543111034299, 10}, 
 
       {0.808116131816352, 0.082212970635652, 0.04017224701514815, 
 
        0.003736953210711456, 0.06576169732213595}, 
 
       {0.810368059256773, 0.0803977424668548, 
 
        0.03595038804967619, 0.003128743020841064, 
 
        0.07015506720585524}, 
 
       {0.2786638394853824, -2.207958372945595, 
 
        -10.50939212805292, -16.27556342228321, 6.680742837579468}}
 
       }], 4], NumberForm[TableForm[{{"Firm\
 
        s", "mc0", "mc1", "p0", "p1", "% change p"}, 
 
      {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway"}, 
 
       {0.4546944106856374, 0.7906026026416039, 
 
        0.7989565388119009, 0.805228644235089}, 
 
       {0.4546944106856374, 0.7906026026416039, 
 
        0.7989565388119009, 0.805228644235089}, 
 
       {1., 0.9, 0.9, 0.9}, 
 
       {1.00647564231634, 0.909435762924599, 0.917789699094896, 
 
        0.924061804517996}, 
 
       {0.6475642316340347, 1.048418102733262, 1.976633232766267, 
 
        2.673533835332864}}}], 4], 
 
   NumberForm[TableForm[{{"firms", "p0-mc0", "p1-mc1", "elas0"\
 
        , "elas1"}, {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway"}, 
 
       {0.5453055893143627, 0.1093973973583961, 
 
        0.1010434611880991, 0.0947713557649114}, 
 
       {0.5517812316307031, 0.1188331602829954, 
 
        0.1188331602829954, 0.1188331602829071}, 
 
       {1.833834128231121, 7.894161575671567, 8.25576645174861, 
 
        8.56915734434871}, 
 
       {1.824048344924428, 7.992702409632988, 8.45598393479825, 
 
        8.80362792686269}}}], 3], 
 
   NumberForm[TableForm[{{"firms", "prof0", "prof1", "change\
 
        prof", "% change prof"}, 
 
      {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway"}, 
 
       {0.4406702434945592, 0.00899388501664258, 
 
        0.004059142882113855, 0.0003541561222091631}, 
 
       {0.4471458858108845, 0.00955391781695475, 
 
        0.004272098225343053, 0.0003717984208796332}, 
 
       {0.006475642316325303, 0.0005600328003121675, 
 
        0.0002129553432291993, 0.00001764229867047009}, 
 
       {1.469498431519408, 6.226817435133587, 5.246313061990563, 
 
        4.981503230953783}}}], 3], 
 
   NumberForm[TableForm[{{"vars.", "pre merger", "post", "change"\
 
        , "% change"}, {{"Guidelines HHI", "Quantity HHI", "Indust\
 
         ry Price", "Industry Quantity", "Elasticity", "Average\
 
         Costs", "Merged Firm Price", "Merged Firm Prft", "Industr\
 
         y Profits", "Consumer Surplus", "Welfare"}, 
 
       {7578.34, 7578.34, 0.9865, 0.934238302677864, 
 
        0.6200000000000001, 0.5004597400213895, 0.9, 
 
        0.01340718402096559, 0.4540774275155248, " ", " "}, 
 
       {7664.500000000002, 7760.376052282459, 0.994379073707049, 
 
        0.929844932794145, 0.6667033037205426, 0.4982278510642111, 
 
        0.912332460522851, 0.01419781446317743, 0.4613437002740\
 
         62, " ", " "}, {86.1600000000008, 182.0360522824585, 
 
        0.007879073707048767, -0.004393369883719301, 
 
        0.04670330372054254, -0.002231888957178407, 
 
        0.01233246052285042, 0.0857864653108454, 
 
        0.7884187385898443, -0.7342259276506884, 
 
        0.05419281093915585}, 
 
       {" ", " ", 0.7986896814038192, -0.4702622308597526, 
 
        7.532790922668165, -0.445967733005459, 1.370273391427812, 
 
        5.897065640148447, 1.600227696473344, " ", " "}}}], 4]}]
;[o]
DIFFERENTIATED PRODUCTS MERGER SIMULATION RESULTS
Elasticity = 0.62
B = 9.557
Nest Parameter = 0.9
@ signifies nest member
* signifies merging firms
Changes in profits and welfare are expressed as a % of pre-merger\
 
  revenue.

Firms           a       q0         q1         % change q

  NTT           22.07   0.8081     0.8104     0.2787
@*DDI           18.87   0.08221    0.0804     -2.208
@*Telecom       18.22   0.04017    0.03595    -10.51
@*Teleway       16.09   0.003737   0.003129   -16.28
  No Purchase   10      0.06576    0.07016    6.681

Firms       mc0      mc1      p0    p1       % change p

  NTT       0.4547   0.4547   1.    1.006    0.6476
@*DDI       0.7906   0.7906   0.9   0.9094   1.048
@*Telecom   0.799    0.799    0.9   0.9178   1.977
@*Teleway   0.8052   0.8052   0.9   0.9241   2.674

firms       p0-mc0   p1-mc1   elas0   elas1

  NTT       0.545    0.552    1.83    1.82
@*DDI       0.109    0.119    7.89    7.99
@*Telecom   0.101    0.119    8.26    8.46
@*Teleway   0.0948   0.119    8.57    8.8

firms       prof0      prof1      change prof   % change prof

  NTT       0.441      0.447      0.00648       1.47
@*DDI       0.00899    0.00955    0.00056       6.23
@*Telecom   0.00406    0.00427    0.000213      5.25
@*Teleway   0.000354   0.000372   0.0000176     4.98

vars.               pre merger   post     change      % change

Guidelines HHI      7578.        7665.    86.16        
Quantity HHI        7578.        7760.    182.         
Industry Price      0.9865       0.9944   0.007879    0.7987
Industry Quantity   0.9342       0.9298   -0.004393   -0.4703
Elasticity          0.62         0.6667   0.0467      7.533
Average Costs       0.5005       0.4982   -0.002232   -0.446
Merged Firm Price   0.9          0.9123   0.01233     1.37
Merged Firm Prft    0.01341      0.0142   0.08579     5.897
Industry Profits    0.4541       0.4613   0.7884      1.6
Consumer Surplus                          -0.7342      
Welfare                                   0.05419
:[font = subsection; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 merger synergies
:[font = input; preserveAspect; startGroup]
?DiffProdMergerMinCost
:[font = print; inactive; preserveAspect; endGroup]
DiffProdMergerMinCost[merging_List, (nested_List), (nestParam_),
   {b,elasticity}, {FirmNames,p0,q0}] This function calls all the
   other functions to calculate the effects of a merger in which
   the merged firm produces at the minimum of the marginal costs of
   the merging firms.
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
DiffProdMergerMinCost[merging={2,3,4},nest={2,3,4},nestParam=.9,demandData,firmData]
:[font = output; output; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; fontLeading = 0; endGroup; endGroup; endGroup]
TableForm[{"DIFFERENTIATED PRODUCTS MERGER SIMULATION RESULTS"
           "Elasticity = 0.62"
           "B = 9.557"
           "Nest Parameter = 0.9"
           "@ signifies nest member"
           "* signifies merging firms"
           "Changes in profits and welfare are expressed as a % of\
            
             pre-merger revenue."
 
    , NumberForm[TableForm[{{"Firms", "a", "q0", "q1", "% change\
 
        q"}, {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway", "  No\
 
         Purchase"}, {22.06566821441421, 18.86736931835656, 
 
        18.22284628945038, 16.08543111034299, 10}, 
 
       {0.808116131816352, 0.082212970635652, 0.04017224701514815, 
 
        0.003736953210711456, 0.06576169732213595}, 
 
       {0.809874365876439, 0.07885244962995133, 
 
        0.03853017425099905, 0.00358420225594238, 
 
        0.06915880798666843}, 
 
       {0.2175719541861465, -4.087580073701148, 
 
        -4.087580073700881, -4.087580072751163, 5.165789209928096}}
 
       }], 4], NumberForm[TableForm[{{"Firm\
 
        s", "mc0", "mc1", "p0", "p1", "% change p"}, 
 
      {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway"}, 
 
       {0.4546944106856374, 0.7906026026416039, 
 
        0.7989565388119009, 0.805228644235089}, 
 
       {0.4546944106856374, 0.7906026026416039, 
 
        0.7906026026416039, 0.7906026026416039}, 
 
       {1., 0.9, 0.9, 0.9}, 
 
       {1.005042848981002, 0.909637183964598, 0.909637183964598, 
 
        0.909637183964598}, 
 
       {0.5042848981001713, 1.070798218288704, 1.070798218288704, 
 
        1.070798218288704}}}], 4], 
 
   NumberForm[TableForm[{{"firms", "p0-mc0", "p1-mc1", "elas0"\
 
        , "elas1"}, {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway"}, 
 
       {0.5453055893143627, 0.1093973973583961, 
 
        0.1010434611880991, 0.0947713557649114}, 
 
       {0.5503484382953645, 0.1190345813229945, 
 
        0.1190345813229945, 0.1190345813229945}, 
 
       {1.833834128231121, 7.894161575671567, 8.25576645174861, 
 
        8.56915734434871}, 
 
       {1.826193696658785, 8.00790647911061, 8.35844425140331, 
 
        8.66224365405667}}}], 3], 
 
   NumberForm[TableForm[{{"firms", "prof0", "prof1", "change\
 
        prof", "% change prof"}, 
 
      {{"  NTT", "@*DDI", "@*Telecom", "@*Teleway"}, 
 
       {0.4406702434945592, 0.00899388501664258, 
 
        0.004059142882113855, 0.0003541561222091631}, 
 
       {0.4457130924755467, 0.00938616832799377, 
 
        0.004586423160269696, 0.0004266440149130336}, 
 
       {0.005042848980987391, 0.0003922833113511898, 
 
        0.000527280278155841, 0.0000724878927038704}, 
 
       {1.144358861401009, 4.361666961777874, 12.989941311976, 
 
        20.46777908333301}}}], 3], 
 
   NumberForm[TableForm[{{"vars.", "pre merger", "post", "change"\
 
        , "% change"}, {{"Guidelines HHI", "Quantity HHI", "Indust\
 
         ry Price", "Industry Quantity", "Elasticity", "Average\
 
         Costs", "Merged Firm Price", "Merged Firm Prft", "Industr\
 
         y Profits", "Consumer Surplus", "Welfare"}, 
 
       {7578.34, 7578.34, 0.9865, 0.934238302677864, 
 
        0.6200000000000001, 0.5004597400213895, 0.9, 
 
        0.01340718402096559, 0.4540774275155248, " ", " "}, 
 
       {7664.500000000002, 7738.676232932834, 0.992644471479517, 
 
        0.930841192013332, 0.6560890859986772, 0.4983471284670755, 
 
        0.909637183964598, 0.0143992355031765, 0.46011232797872\
 
         31, " ", " "}, {86.1600000000008, 160.3362329328338, 
 
        0.006144471479516578, -0.00339711066453241, 
 
        0.03608908599867711, -0.002112611554314026, 
 
        0.00963718396459801, 0.1076414283102647, 
 
        0.6548100750993531, -0.5718434980990277, 
 
        0.0829665770003254}, 
 
       {" ", " ", 0.6228556999003044, -0.3636235695748113, 
 
        5.820820322367282, -0.42213416692094, 1.07079821828866, 
 
        7.399402295512414, 1.329046567282188, " ", " "}}}], 4]}]
;[o]
DIFFERENTIATED PRODUCTS MERGER SIMULATION RESULTS
Elasticity = 0.62
B = 9.557
Nest Parameter = 0.9
@ signifies nest member
* signifies merging firms
Changes in profits and welfare are expressed as a % of pre-merger\
 
  revenue.

Firms           a       q0         q1         % change q

  NTT           22.07   0.8081     0.8099     0.2176
@*DDI           18.87   0.08221    0.07885    -4.088
@*Telecom       18.22   0.04017    0.03853    -4.088
@*Teleway       16.09   0.003737   0.003584   -4.088
  No Purchase   10      0.06576    0.06916    5.166

Firms       mc0      mc1      p0    p1       % change p

  NTT       0.4547   0.4547   1.    1.005    0.5043
@*DDI       0.7906   0.7906   0.9   0.9096   1.071
@*Telecom   0.799    0.7906   0.9   0.9096   1.071
@*Teleway   0.8052   0.7906   0.9   0.9096   1.071

firms       p0-mc0   p1-mc1   elas0   elas1

  NTT       0.545    0.55     1.83    1.83
@*DDI       0.109    0.119    7.89    8.01
@*Telecom   0.101    0.119    8.26    8.36
@*Teleway   0.0948   0.119    8.57    8.66

firms       prof0      prof1      change prof   % change prof

  NTT       0.441      0.446      0.00504       1.14
@*DDI       0.00899    0.00939    0.000392      4.36
@*Telecom   0.00406    0.00459    0.000527      13.
@*Teleway   0.000354   0.000427   0.0000725     20.5

vars.               pre merger   post     change      % change

Guidelines HHI      7578.        7665.    86.16        
Quantity HHI        7578.        7739.    160.3        
Industry Price      0.9865       0.9926   0.006144    0.6229
Industry Quantity   0.9342       0.9308   -0.003397   -0.3636
Elasticity          0.62         0.6561   0.03609     5.821
Average Costs       0.5005       0.4983   -0.002113   -0.4221
Merged Firm Price   0.9          0.9096   0.009637    1.071
Merged Firm Prft    0.01341      0.0144   0.1076      7.399
Industry Profits    0.4541       0.4601   0.6548      1.329
Consumer Surplus                          -0.5718      
Welfare                                   0.08297
:[font = section; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 Cournot Simulation Inputs
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
FirmNames={
           "AT&T",
           "MCI",
           "Sprint",
           "Fringe Firm",
           "Fringe Firm",
           "Fringe Firm"};

Revenue0={.622,.150,.097,.131/3,.131/3,.131/3};
p0={.1661,.1586,.1621,.1621,.1621,.1621};
quantities=(Revenue0/p0);
q0=quantities/Apply[Plus,quantities];
NumberForm[
            TableForm[
                      Transpose[
         {{"Firms",FirmNames},
          {"P0",p0},
          {"Q0",q0}}
                                ]
                      ]
         ,4]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup; endGroup]
NumberForm[TableForm[{{"Firms", "P0", "Q0"}, 
 
    {{"AT&T", "MCI", "Sprint", "Fringe Firm", "Fringe Firm", "Fring\
 
       e Firm"}, {0.1661, 0.1586, 0.1621, 0.1621, 0.1621, 0.1621}, 
 
     {0.6141878540427865, 0.1551202684205855, 0.0981452286011093, 
 
      0.04418221631183958, 0.04418221631183958, 0.04418221631183958}
 
      }}], 4]
;[o]
Firms         P0       Q0

AT&T          0.1661   0.6142
MCI           0.1586   0.1551
Sprint        0.1621   0.09815
Fringe Firm   0.1621   0.04418
Fringe Firm   0.1621   0.04418
Fringe Firm   0.1621   0.04418
:[font = section; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
 Cournot Simulation
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468]
pbar=p0.q0;
n=Length[q0];
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
?HomoProdMerger
:[font = print; inactive; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; endGroup]
HomoProdMerger[merging_List, elasticity_ ,p0_, s0_List,
   FirmNames_List] inputs model primitives for simulation of a
   merger in a linear Cournot model in which firms are distinguished
   on the basis of their marginal costs, which are determines by
   their capital stocks.  It computes and outputs the effects of a
   merger.
:[font = input; wordwrap; preserveAspect; leftWrapOffset = 15; leftNameWrapOffset = 0; rightWrapOffset = 468; startGroup]
HomoProdMerger[{1,2},.7,pbar,q0,FirmNames]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup; endGroup; endGroup]
"HOMOGENEOUS PRODUCTS MERGER SIMULATION"
"Elasticity = 0.7"
"* denotes merging firm"
"Changes in consumer surplus and welfare are expressed as a % of\
 
  premerger revenue."
" "
NumberForm[TableForm[{{"Firms", "K0", "mc0", "q0", "cost0", "prof\
 
      0"}, {{"*AT&T", "*MCI", " Sprint", " Fringe Firm", " Fringe\
 
       Firm", " Fringe Firm"}, 
 
     {1.309658176888099, 0.05209228309897883, 0.02983891181011511, 
 
      0.01232735225807857, 0.01232735225807857, 0.01232735225807857}
 
      , {0.02010625537124025, 0.1276683027506505, 
 
      0.1410178663540145, 0.1536616954249063, 0.1536616954249063, 
 
      0.1536616954249063}, {0.02633232175354506, 
 
      0.006650533369653024, 0.004207819677788037, 
 
      0.001894241848076401, 0.001894241848076401, 
 
      0.001894241848076401}, 
 
     {0.000264722192847221, 0.0004245311538450833, 
 
      0.0002966888764820529, 0.0001455362069601138, 
 
      0.0001455362069601138, 0.0001455362069601138}, 
 
     {0.004054142763296614, 0.0006662482988248185, 
 
      0.0003934517468271927, 0.0001651456543921582, 
 
      0.0001651456543921582, 0.0001651456543921582}}}], 4]
" "
NumberForm[TableForm[{{"Firms", "K1", "mc1", "q1", "cost1", "prof\
 
      1"}, {{"Merged Firm", "Sprint", "Fringe Firm", "Fringe Firm"\
 
       , "Fringe Firm"}, {1.361750459987078, 0.02983891181011511, 
 
      0.01232735225807857, 0.01232735225807857, 0.01232735225807857}
 
      , {0.02133902348989572, 0.1548872410450442, 
 
      0.1687746146925736, 0.1687746146925736, 0.1687746146925736}, 
 
     {0.02905842505304057, 0.004621666726055115, 
 
      0.002080544127536839, 0.002080544127536839, 
 
      0.002080544127536839}, 
 
     {0.0003100392073931035, 0.0003579186041141793, 
 
      0.0001755715167379633, 0.0001755715167379633, 
 
      0.0001755715167379633}, 
 
     {0.004924687922181595, 0.0004746510947106337, 
 
      0.0001992279009460591, 0.0001992279009460591, 
 
      0.0001992279009460591}}}], 4]
" "
NumberForm[TableForm[{{"Variables", "Pre", "Post", "Change", "%Chan\
 
      ge"}, {{"Guidelines HHI", "Quantity HHI", "Capacity HHI"\
 
       , "Industry Price", "Industry Quantity", "elasticity", "Merg\
 
       ed Firm Profits", "Industry Av. Costs", "Industry Profits"\
 
       , "Consumer Surplus", "Total Welfare"}, 
 
     {4167.777083404004, 4167.777083404004, 8424.39554896235, 
 
      0.1640138304766991, 0.04287340034521532, 0.7, 
 
      0.004720391062121432, 0.03318026637962845, " ", " ", " "}, 
 
     {6073.236778999611, 5513.669876616698, 9092.98177719316, 
 
      0.1801449018664883, 0.0399217241617062, 0.825692204365732, 
 
      {0.004924687922181595}, 0.02992536987836635, " ", " ", " "}, 
 
     {1905.459695595606, 1345.892793212694, 668.5862282308063, 
 
      0.01613107138978925, -0.002951676183509125, 
 
      0.1256922043657316, {0.0002042968600601625}, 
 
      -0.003254896501262098, 5.514111029823937, -9.49663136847012, 
 
      -3.982520338646168}, {" ", " ", " ", 9.83518971717507, 
 
      -6.884632802022507, 17.95602919510451, {4.327964725201129}, 
 
      -9.80973589549146, " ", " ", " "}}}], 4]
;[o]
HOMOGENEOUS PRODUCTS MERGER SIMULATION
Elasticity = 0.7
* denotes merging firm
Changes in consumer surplus and welfare are expressed as a % of\
 
  premerger revenue.
 
Firms          K0        mc0       q0         cost0       prof0

*AT&T          1.31      0.02011   0.02633    0.0002647   0.004054
*MCI           0.05209   0.1277    0.006651   0.0004245   0.0006662
 Sprint        0.02984   0.141     0.004208   0.0002967   0.0003935
 Fringe Firm   0.01233   0.1537    0.001894   0.0001455   0.0001651
 Fringe Firm   0.01233   0.1537    0.001894   0.0001455   0.0001651
 Fringe Firm   0.01233   0.1537    0.001894   0.0001455   0.0001651
 
Firms         K1        mc1       q1         cost1       prof1

Merged Firm   1.362     0.02134   0.02906    0.00031     0.004925
Sprint        0.02984   0.1549    0.004622   0.0003579   0.0004747
Fringe Firm   0.01233   0.1688    0.002081   0.0001756   0.0001992
Fringe Firm   0.01233   0.1688    0.002081   0.0001756   0.0001992
Fringe Firm   0.01233   0.1688    0.002081   0.0001756   0.0001992
 
Variables             Pre       Post       Change      %Change

Guidelines HHI        4168.     6073.      1905.        
Quantity HHI          4168.     5514.      1346.        
Capacity HHI          8424.     9093.      668.6        
Industry Price        0.164     0.1801     0.01613     9.835
Industry Quantity     0.04287   0.03992    -0.002952   -6.885
elasticity            0.7       0.8257     0.1257      17.96
Merged Firm Profits   0.00472   0.004925   0.0002043   4.328
Industry Av. Costs    0.03318   0.02993    -0.003255   -9.81
Industry Profits                           5.514        
Consumer Surplus                           -9.497       
Total Welfare                              -3.983
^*)
