(* :Title: Message Utilities *)
(* :Context: Utilities`Message` *)
(* :Author: Paul A. Rubin *)
(* :Affiliation:
	Department of Management
	Eli Broad Graduate School of Management
	Michigan State University
	East Lansing, MI  48824-1122
	Phone:	517/336-3509
	Fax:	517/336-1111
	Net:	rubin@msu.edu *)
(* :Summary:
	This package provides a utility for determining the status
	(on or off) of any Mathematica message. *)
(* :Package Version: 1.0 *)
(* :Mathematica Version: 2.1 *)
(* :Copyright: Copyright 1994, Paul A. Rubin *)
(* :Keywords: message, On, Off *)
(* :Limitations: *)
(* :Discussion: *)

BeginPackage["Message`" ];

MessageQ::usage = "MessageQ[ symbol::tag ] returns the value True if the
message symbol::tag is currently turned on, False if it is currently
turned off.";

Begin["`Private`"];

MessageQ[ msg_MessageName ] := !MatchQ[ msg, $Off[ ___ ] ];

SetAttributes[ MessageQ, HoldFirst ];

End[];
EndPackage[];
