(*^

::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "NeXT Mathematica Notebook Front End Version 2.2";

	NeXTStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e8,  24, "Times"; ;
	fontset = subtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, L1, e6,  18, "Times"; ;
	fontset = subsubtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, L1, e6,  14, "Times"; ;
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, L1, a20,  18, "Times"; ;
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, L1, a15,  14, "Times"; ;
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, L1, a12,  12, "Times"; ;
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  10, "Times"; ;
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L1,  12, "Courier"; ;
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; ;
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L1,  12, "Courier"; ;
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287, L1,  12, "Courier"; ;
	fontset = name, inactive, noPageBreakInGroup, nohscroll, preserveAspect, M7, italic, B65535, L1,  10, "Times"; ;
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic, L1,  12, "Times"; ;
	fontset = leftheader,  12;
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, italic, L1,  12, "Times"; ;
	fontset = leftfooter,  12;
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12, "Courier"; ;
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, L1,  12;
	automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
PWS:  A Package for Piecewise Smooth Functions of a Single Real Variable
:[font = subtitle; inactive; preserveAspect]
Detailed Package Walk-through
:[font = subsubtitle; inactive; preserveAspect]
by Paul A. Rubin
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Abstract
:[font = text; inactive; preserveAspect; endGroup]
Package PWS` adds to Mathematica limited support for piecewise smooth functions of a single (real) argument.  In this notebook, we describe and demonstrate the major features of the package.
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Author Information
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Address
:[font = name; inactive; preserveAspect; endGroup]
Department of Management
The Eli Broad Graduate School of Management
Michigan State University
East Lansing, MI  48824-1122
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Telephone
:[font = name; inactive; preserveAspect; endGroup]
(517) 432-3509
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Fax
:[font = name; inactive; preserveAspect; endGroup]
(517) 432-1111
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Internet
:[font = name; inactive; preserveAspect; endGroup; endGroup]
rubin@msu.edu
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Overview
:[font = text; inactive; preserveAspect]
PWS` is a Mathematica package designed to support operations on piecewise smooth functions of a single real variable.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
We use the term "piecewise smooth" here to denote a function defined on the disjoint union of a finite number of intervals and isolated points, such that the function behaves in a smooth manner over each interval of the domain.  The function, or any of its derivatives, may suffer discontinuities at isolated points, but not within the individual intervals comprising the domain.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Smoothness
:[font = text; inactive; preserveAspect; endGroup; endGroup]
Any reference to smoothness here means "having sufficient differentiability to let you get away with whatever you are trying to do."  The package imposes no specific minimum differentiability requirement, but certain operations (for instance, FindMinimum) may seek to compute and use derivatives.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Domains
:[font = text; inactive; preserveAspect; endGroup; endGroup]
All functions treated by this package take a single real argument and produce a real result.  "Extended real" function values (Infinity, -Infinity) can be included at the user's risk.  Function domains are expressed as a (disjoint) list of intervals and isolated points.
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Prolog
:[font = text; inactive; preserveAspect]
First things first - we will load the package and establish a context for the walk-through (so that we do not leave crumbs lying around when we are done).
:[font = input; preserveAspect]
Needs[ "PWS`" ];  (* load stuff *)
:[font = input; preserveAspect]
Needs[ "Utilities`Message`" ];
:[font = input; preserveAspect]
Begin[ "PWSWalkThrough`" ];  (* establish a context *)
:[font = input; preserveAspect; endGroup]
(* turn off annoying messages about spelling *)
sp = MessageQ[ General::spell ];  Off[ General::spell ];
sp1 = MessageQ[ General::spell1 ]; Off[ General::spell1 ];
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Infinitesimals
:[font = text; inactive; preserveAspect]
Mathematica does not support the standard mathematical notation for intervals:  (a, b) for an open interval, [a, b] for a closed interval, and (a, b] or [a, b) for a semi-open interval.  To circumvent this, we employ the concepts of 'infinitesimally above' or 'infinitesimally below.'
:[font = text; inactive; preserveAspect]
We therefore introduce the symbols IA[] and IB[].  IA[expr] denotes a value 'infinitesimally above' the value of 'expr.'  That is, IA[expr] > expr, and x > IA[expr] whenever x > expr.  Similarly, IB[expr] denotes a value 'infinitesimally below' the value of 'expr.'
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Infinitesimal Adjustments of Infinitesimal Adjustments
:[font = text; inactive; preserveAspect]
Composing IA[] or IB[] with itself has no effect.  In essence, the sum of two infinitesimals is infinitesimal.
:[font = input; preserveAspect]
{IA[ IA[ 3 ] ], IB[ IB[ 2 ] ]}
:[font = text; inactive; preserveAspect]
Composing IA[] with IB[] produces an indeterminate result.  Is something slightly more than slightly less than 2 more or less than 2?
:[font = input; preserveAspect; endGroup]
IA[ IB[ 2 ] ]
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Intervals
:[font = text; inactive; preserveAspect]
To express intervals, we combine the IA[] and IB[] operators with lists.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Closed Intervals and Isolated Points
:[font = text; inactive; preserveAspect; endGroup]
We denote the closed interval [a, b] by the Mathematica expression {a, b}.  Similarly, we denote the isolated point a by {a}.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Open and Semi-open Intervals
:[font = text; inactive; preserveAspect; endGroup]
We represent the open interval (a, b) with the Mathematica expression {IA[ a ], IB[ b ]}.  Similarly, the semi-open intervals (a, b] and [a, b) are denoted {IA[ a ], b} and {a, IB[ b ]} respectively.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Unbounded Intervals
:[font = text; inactive; preserveAspect; endGroup; endGroup]
Intervals with infinite endpoints, such as {-Infinity, b} or {a, Infinity}, are effectively open at the infinite end.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Infinitesimals and Infinity
:[font = text; inactive; preserveAspect]
Infinitesimal adjustments to Infinity and -Infinity are uninterpretable, and hence are ignored.
:[font = input; preserveAspect; endGroup]
{IB[ Infinity ], IA[ -Infinity ]}
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Basic Operations with Infinitesimals
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Arithmetic
:[font = text; inactive; preserveAspect]
The four basic arithmetic operations (addition, subtraction, multiplication and division) have been extended to behave consistently with infinitesimals.
:[font = input; preserveAspect]
IA[ 4 ] + IA[ 2.5 ]
:[font = input; preserveAspect]
2 - 3 IA[ 4 ]
:[font = text; inactive; preserveAspect]
Addition or multiplication of unlike infinitesimals (IA[] with IB[]), or subtraction or division of like infinitesimals (IA[] with IA[] or IB[] with IB[]), produces indeterminate results.
:[font = input; preserveAspect; endGroup]
{IA[ 2 ] + IB[ 3 ], IA[ 3 ] - IA[ 2 ],
 IA[ 2 ]*IB[ 3 ], IA[ 3 ]/IA[ 2 ]}
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Powers
:[font = text; inactive; preserveAspect]
Since exponentiation can, in general, produce complex results, only certain specific cases have been extended to treat infinitesimals.
:[font = text; inactive; preserveAspect]
If the base is a positive number, infinitesimally adjusted powers can be calculated:
:[font = input; preserveAspect]
3^IA[ 2 ]
:[font = input; preserveAspect]
(1/3)^IA[ 2 ]
:[font = text; inactive; preserveAspect]
Note that, for this to apply, the base must evaluate to a number, not a symbolic constant.  Thus it fails in the next case:
:[font = input; preserveAspect]
Pi^IA[ 2 ]  (* result should be IA[ Pi^2 ] *)
:[font = input; preserveAspect]
TrueQ[ Pi > 1 ]  (* is Pi recognized as a number > 1? *)
:[font = input; preserveAspect]
TrueQ[ N[ Pi ] > 1 ]  (* suppose we convert to a real *)
:[font = input; preserveAspect]
N[ Pi ]^IA[ 2 ]  (* it works when the base is a real *)
:[font = text; inactive; preserveAspect]
Powers of an infinitesimally adjusted base can also be computed, provided that the unadjusted base is positive:
:[font = input; preserveAspect]
IA[ 3 ]^(-2)
:[font = input; preserveAspect; endGroup]
IB[ 3 ]^(2)
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Relational Operators
:[font = text; inactive; preserveAspect]
The relational operators for numbers (<, >, <=, >=, ==, !=) have been extended to handle infinitesimals:
:[font = input; preserveAspect]
IA[ 3 ] > 3
:[font = input; preserveAspect]
IB[ 2 ] >= 2
:[font = input; preserveAspect]
IA[ 3 ] >= IA[ 2.99 ]
:[font = input; preserveAspect]
IA[ 3 ] > IA[ 3 ]
:[font = text; inactive; preserveAspect]
Note that relational comparisons of infinitesimally adjusted symbolic constants suffer the same vagaries that all comparisons of non-numeric symbols suffer in Mathematica:
:[font = input; preserveAspect]
Clear[ x ];  (* lets make sure x is undefined *)
:[font = input; Cclosed; preserveAspect; startGroup]
test = IA[ x ] > x  (* seems like this should be true *)
:[font = output; output; inactive; preserveAspect; endGroup]
x >= x







;[o]
x >= x
:[font = text; inactive; preserveAspect]
Mathematica recognizes that "IA[ x ] > x" is as true as the statement "x >= x" (which looks pretty plausible if x is a number).  Since x is not a number, though, Mathematica does not recognize the truth of the statement:
:[font = input; preserveAspect]
TrueQ[ test ]
:[font = text; inactive; preserveAspect]
This is cured when x is assigned a value:
:[font = input; preserveAspect]
x = 0; TrueQ[ test ]
:[font = text; inactive; preserveAspect]
It is self-evident that IA[ x ] does not equal y as long as y is not also given the value IA[ x ].  Our position is that IA[ x ] should also not be regarded as equal to IA[ x ].  Thinking of IA[ x ] as "x plus epsilon for some small epsilon," the issue is whether "x plus epsilon" and "x plus some other epsilon" should be treated as equal.  One can argue either side of this; we took what we perceive to be the conservative approach.
:[font = input; preserveAspect]
IA[ 3 ] == IA[ 3 ]
:[font = input; preserveAspect]
IA[ 3 ] != IA[ 3 ]
:[font = text; inactive; preserveAspect]
At the same time, in order to make the use of infinitesimals as endpoints of open intervals work as desired, we accept as true the propositions that IA[ x ] <= IA[ x ] and IB[ x ] <= IB[ x ]:
:[font = input; preserveAspect; endGroup]
{IA[ 4 ] <= IA[ 4 ], IB[ 4 ] >= IB[ 4 ]}
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Sorting
:[font = text; inactive; preserveAspect]
The Sort function has been extended to process infinitesimals as numbers.  The result is that a fully numeric list (containing infinitesimals) is sorted into numerical order:
:[font = input; preserveAspect]
Sort[ {3.5, -6.8, IB[ -6.8 ], IA[ 3.5 ]} ]
:[font = text; inactive; preserveAspect]
When not all elements of the list are numeric, sorting is by canonical order (rather than numerical order):
:[font = input; preserveAspect]
Clear[ f ];  (* remove any definition for f *)
:[font = input; preserveAspect; endGroup]
Sort[ {IB[ 9 ], 9, IA[ 9 ], f[ 9 ]} ]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Removing Infinitesimals
:[font = text; inactive; preserveAspect]
The function StripInfs[] removes all infinitesimals from an expression by converting IA[x] or IB[x] to just 'x'.
:[font = input; preserveAspect; endGroup; endGroup]
StripInfs[ {0, IB[1], IA[1.2], IB[ Pi ]} ]
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Other Operations with Infinitesimals
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Absolute Values
:[font = text; inactive; preserveAspect]
The absolute value function works with infinitesimals.
:[font = input; preserveAspect; endGroup]
Abs[ {IB[ -2 ], IA[ -2 ], IB[ 3 ], IA[ 3 ]} ]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Sign Predicates and Signum
:[font = text; inactive; preserveAspect]
The sign predicates (Positive, Negative, NonNegative) and the signum function (Sign[]) work with infinitesimals:
:[font = input; preserveAspect]
test = {IA[ 0 ], IB[ 0 ], IA[ -1 ], IB[ 1 ]};
:[font = input; preserveAspect]
Positive[ test ]
:[font = input; preserveAspect]
Negative[ test ]
:[font = input; preserveAspect]
NonNegative[ test ]
:[font = input; preserveAspect; endGroup]
Sign[ test ]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Truncation Operators
:[font = text; inactive; preserveAspect]
The Chop[] function ignores infinitesimals, with the exception that values infinitesimally different from zero are truncated to zero.
:[font = input; preserveAspect]
Chop /@ {IB[ .00001 ], IA[ 0 ], IB[ 0 ], IA[ -.0000001 ]}
:[font = text; inactive; preserveAspect]
Floor[] and Ceiling[] treat infinitesimals properly.  Let us create an array of test values:
:[font = input; preserveAspect]
test = {IB[ # ], #, IA[ # ]}& /@ 
                {-6.3, -4, 0, 2.7, 9} // MatrixForm
:[font = input; preserveAspect]
Floor /@ test
:[font = input; preserveAspect; endGroup]
Ceiling /@ test
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Max and Min
:[font = text; inactive; preserveAspect]
The Max[] and Min[] operators correctly handle infinitesimals:
:[font = input; preserveAspect]
Max[ {2.5, IA[ 2.5 ], IB[ 2.5 ]}, {IA[ 2.4 ], 2.4} ]
:[font = input; preserveAspect; endGroup]
Min[ {-4.7, IA[ -4.7 ]}, IB[ -4.7 ] ]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Monotone Functions
:[font = text; inactive; preserveAspect]
Infinitesimal adjustment operators commute with strictly increasing functions.  The global variable IncreasingFunctions lists those functions identified as increasing.
:[font = input; preserveAspect]
IncreasingFunctions
:[font = input; preserveAspect]
Log[ {IA[ 10 ], IB[ 12 ]} ]
:[font = text; inactive; preserveAspect]
Infinitesimal adjustment operators are anti-commutative with strictly decreasing functions.  The global variable DecreasingFunctions lists those functions identified as decreasing.
:[font = input; preserveAspect]
DecreasingFunctions
:[font = input; preserveAspect]
ArcCos[ {IA[ Sqrt[ 1/2 ] ], IB[ Sqrt[ 1/2 ] ]} ]
:[font = text; inactive; preserveAspect; endGroup]
You are free to add function to, or remove functions from, these lists.  (You will first need to Unprotect[] the lists.)
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Infinitesimals as Limits
:[font = text; inactive; preserveAspect]
It may sometimes be useful to evaluate certain functions at infinitesimally adjusted arguments by passing to a limit.  The lists IAToLimit and IBToLimit enumerate those functions for which IA[] and IB[] respectively should be converted to limits.  The package loads with those lists empty, but you are free to add functions as needed (unprotecting the lists first).
:[font = text; inactive; preserveAspect]
As an example, let us define a new function:
:[font = input; preserveAspect]
f[ x_ ] := Sin[ x ]/x  (* familiar to calculus students *)
:[font = text; inactive; preserveAspect]
Note that f is not well-defined at or "near" 0.
:[font = input; preserveAspect]
f /@ {0, IA[ 0 ], IB[ 0 ]}
:[font = text; inactive; preserveAspect]
Let us add f to the lists of functions for which IA and IB are converted to limits:
:[font = input; preserveAspect]
Unprotect[ IAToLimit];
AppendTo[ IAToLimit, f ]
Protect[ IAToLimit ];
:[font = input; preserveAspect]
Unprotect[ IBToLimit ];
AppendTo[ IBToLimit, f ]
Protect[ IBToLimit ];
:[font = input; preserveAspect]
f /@ {0, IA[ 0 ], IB[ 0 ]}
:[font = text; inactive; preserveAspect]
The function is still indeterminate at 0, but it behaves in the expected manner "near" 0.  Before proceeding, we will remove f from the lists.
:[font = input; preserveAspect; endGroup]
Unprotect[ IAToLimit, IBToLimit ];
IAToLimit = DeleteCases[ IAToLimit, f ]
DeleteCases[ IBToLimit, f ]
Protect[ IAToLimit, IBToLimit ];
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Ignoring Infinitesimals
:[font = text; inactive; preserveAspect]
In some cases, the best way to treat infinitesimals is to ignore their presence.  For instance, the expression IA[ x ] should qualify as a number if and only if x does.  The lists IAToValue and IBToValue enumerate those functions for which IA and IB, respectively, should be ignored if wrapped around the argument.
:[font = input; preserveAspect]
IAToValue
:[font = input; preserveAspect]
IBToValue
:[font = input; preserveAspect; endGroup; endGroup; endGroup]
Round[ {IA[ N[ Pi ] ], IB[ N[ Pi ] ]} ]
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
A piecewise smooth function is described by two sets of information:  a list of intervals (or singletons) comprising its domain; and, for each portion of the domain, a formula used to evaluate the function there.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Creating a Piecewise Smooth Function
:[font = text; inactive; preserveAspect]
To create a piecewise smooth function, apply the operator PWS[] to a list of pairs, where the first element of each pair is a singleton ({a}) or interval ({a, b}) and the second element is the function to be applied on that segment of the domain.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Intervals
:[font = text; inactive; preserveAspect]
The domain descriptions can include incremental adjustments (IA, IB) to achieve open-ended intervals.  One restriction is enforced:  singleton points cannot be incrementally adjusted.  Thus {IA[ 3 ]} is not a valid domain segment.
:[font = text; inactive; preserveAspect; endGroup]
Domain segments can contain symbolic parameters (such as {IA[ q1 ], IB[ q2 ]}).  As long as these parameters remain symbolic (i.e., are not assigned numeric values), certain operations (such as Plotting) will not be possible with that function.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Functions
:[font = text; inactive; preserveAspect; endGroup]
The formula for computing values on a particular segment of the domain must be given as a pure function.  For example, if the function doubles its argument on a given segment, the expressions "(2*#)&" and "Function[ x, 2 x ]" are appropriate, but the expression "2 x" is not.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Formatting
:[font = text; inactive; preserveAspect; endGroup]
The function PWSForm can be used to print out a piecewise smooth function in a tabular format.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (creating a function using numeric constants only)
:[font = text; inactive; preserveAspect]
Consider a worker paid a salary of $600 per week (based on a wage rate of $15 per hour and a 40 hour work week), where the full salary is paid even if the worker is sent home early.  The worker receives "time-and-a-half" pay ($22.50 per hour) for up to 10 hours of overtime work, and  "double-time" pay ($30 per hour) for work in excess of 50 hours per week.  Assume a maximum work week of 60 hours.  The cost function for actual hours worked in a week is given by the following piecewise smooth function:
:[font = input; preserveAspect]
thalf =       (* time-&-1/2 costs *)
  Evaluate[ Simplify[ 600 + 22.5(# - 40) ] ]& 
:[font = input; preserveAspect]
dt =          (* double time costs *)
  Evaluate[ Simplify[ 600 + 22.5*10 + 30(# - 50) ] ]&
:[font = input; preserveAspect]
laborcost = 
  PWS[ {
        {{0, 40}, 600&}, 
        {{IA[ 40 ], 50}, thalf},
        {{IA[ 50 ], 60}, dt}
       } ]
:[font = text; inactive; preserveAspect]
The PWSForm of laborcost is a bit easier to read:
:[font = input; preserveAspect]
laborcost // PWSForm
:[font = text; inactive; preserveAspect]
We can compute total labor costs for various numbers of hours worked:
:[font = input; preserveAspect]
Table[ {hrs, laborcost[ hrs ]}, {hrs, 30, 65, 5} ] // 
  TableForm
:[font = text; inactive; preserveAspect; endGroup]
Note that 65 hours is outside the domain of laborcost, so the result returned is Null.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (creating a function using symbolic constants)
:[font = text; inactive; preserveAspect]
To illustrate the use of a symbolic constant in the domain of a piecewise smooth function, we will redefine laborcost using the symbol 'double' to denote the cutoff for qualification for double pay.
:[font = input; preserveAspect]
Clear[ double ];  (* make sure 'double' is undefined *)
:[font = input; preserveAspect]
dt =          (* double time costs using the new cutoff *)
  Evaluate[ Simplify[ 600 + 22.5*10 + 30(# - double) ] ]&
:[font = input; preserveAspect]
laborcost = 
  PWS[ {
        {{0, 40}, 600&}, 
        {{IA[ 40 ], double}, thalf},
        {{IA[ double ], 60}, dt}
       } ];
:[font = text; inactive; preserveAspect]
Without an assignment to 'double,' any argument outside the range [0, 40] results in laborcost evaluating to Null:
:[font = input; preserveAspect]
{laborcost[ 35 ], laborcost[ 55 ]}
:[font = text; inactive; preserveAspect]
If we assign a value to 'double,' laborcost evaluates as before:
:[font = input; preserveAspect]
double = 50;  (* temporarily make double 50 again *)
Table[ {hrs, laborcost[ hrs ]}, {hrs, 30, 65, 5} ] //
  TableForm
:[font = input; preserveAspect; endGroup; endGroup]
Clear[ double ];  (* remove the value of double *)
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Freezing a Piecewise Smooth Function
:[font = text; inactive; preserveAspect]
When a piecewise smooth function contains symbols with unassigned values in its domain, certain operations cannot be performed on it.  For example, the function 'laborcost' created above cannot be plotted, since the plot changes slope when the abscissa equals 'double,' whose value is presently unknown.
:[font = text; inactive; preserveAspect; endGroup]
We will call a piecewise smooth function "frozen" if all endpoints of domain segments (including singletons) are numbers.  To distinguish a frozen piecewise smooth function from one not frozen, we give it a distinct head (PWSf) in place of the standard head (PWS) for piecewise smooth functions.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Creating a Frozen Piecewise Smooth Function
:[font = text; inactive; preserveAspect]
You can create a frozen function in the same way that you create a regular piecewise smooth function, replacing PWS with PWSf.  This is not recommended, however, since we make certain assumptions about frozen functions (not least of which is that their domains have been sorted into ascending order).  The preferred approach is to create a PWS function, make sure all domain limits are numeric, and then apply the function PWSFreeze to it.  PWSFreeze will check for consistency (all domain limits numeric, no overlapping domains); if the check is passed, it will return a PWSf function.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (freezing a PWS function)
:[font = text; inactive; preserveAspect]
Suppose that, in addition to salary (and overtime pay), we spend $120 per week on benefits for the worker, with an additional insurance cost of $0.20 per hour of overtime beyond some limit 'inslim.'
:[font = input; preserveAspect]
benefits = 
  PWS[ {
        {{0, inslim}, 120&},
        {{inslim, Infinity}, 
           120 + .2(# - inslim) &}
       } ]
:[font = text; inactive; preserveAspect]
Let us try to freeze the function:
:[font = input; preserveAspect]
PWSFreeze[ benefits ]
:[font = text; inactive; preserveAspect]
The function is returned unfrozen because the domain endpoint 'inslim' is not numeric.  Now, let us specify a numeric value for the limit and try again:
:[font = input; preserveAspect]
inslim = 45;  (* buy extra insurance after 45 hours *)
:[font = input; preserveAspect]
PWSFreeze[ benefits ]
:[font = text; inactive; preserveAspect]
Freezing again fails, because the two domain intervals are not disjoint.  (The fact the function's value at that point is the same in each segment is insufficient.  Domains must be disjoint for the function to be well-defined.)  So we will rewrite the function.
:[font = input; preserveAspect]
Clear[ inslim ];  (* clear the definition of inslim *)
:[font = input; preserveAspect]
benefits = 
  PWS[ {
        {{0, inslim}, 120&},
        {{IA[ inslim ], Infinity},    (* note the IA *)
           120 + .2(# - inslim) &}
       } ]
:[font = text; inactive; preserveAspect]
Had we not cleared 'inslim,' the temporary value of 45 would have been permanently encoded in 'benefits.'
:[font = input; preserveAspect]
inslim = 45; 
(benefitsf = PWSFreeze[ benefits ]) // PWSForm
:[font = text; inactive; preserveAspect]
This time we get a frozen function.  Note that the domain limits no longer depend on 'inslim,' but the formula for the function on the second segment still does.  If we change 'inslim' later, 'benefits' will adjust, but 'benefitsf' will compute the insurance cost based on the old cutoff.  To freeze the formula as well as the domain, use MapAll to apply Evaluate to every part of 'benefitsf':
:[font = input; preserveAspect]
benefitsf = Evaluate //@ benefitsf;
PWSForm[ benefitsf ]
:[font = text; inactive; preserveAspect]
We can now safely clear the value of 'inslim.'
:[font = input; preserveAspect; endGroup; endGroup; endGroup]
Clear[ inslim ];
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Working with Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
In general, you can use a piecewise smooth function (PWS or PWSf) just as you would any other function in Mathematica.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Utilities
:[font = text; inactive; preserveAspect]
In addition to PWSForm[] (described earlier), which provides a convenient output form for piecewise smooth functions, there are a few utilities to facilitate their use.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Domain Endpoints
:[font = text; inactive; preserveAspect]
Functions LeftEnds[] and RightEnds[] return, respectively, lists of left and right endpoints for the domain intervals of a piecewise smooth function.  Singleton points are considered both left and right endpoints.  For example, using the labor cost function defined above:
:[font = input; preserveAspect]
laborcost // PWSForm
:[font = input; preserveAspect]
LeftEnds[ laborcost ]
:[font = input; preserveAspect; endGroup; endGroup]
RightEnds[ laborcost ]
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Arithmetic
:[font = text; inactive; preserveAspect]
You can perform arithmetic (including powers) with two piecewise smooth functions, or with a piecewise smooth function and a regular function.  The result will typically not be simplified.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (arithmetic with an unfrozen function)
:[font = input; preserveAspect]
Clear[ f ];
f[ h_ ] = laborcost[ h ] - 100
:[font = text; inactive; preserveAspect]
As an aside, we note that since the result above is not a PWS or PWSf function, PWSForm will not print it.
:[font = input; preserveAspect]
double = 50;
:[font = input; preserveAspect]
f[ hours ]
:[font = input; preserveAspect]
f[ 55 ]
:[font = text; inactive; preserveAspect]
Function f[] subtracts 100 from the labor cost of a given number of hours.  With the parameter 'double' given a numerical value (50 here), applying f to a numeric argument yields a numeric result, but the formula for f[] remains unsimplified.
:[font = text; inactive; preserveAspect]
A different approach is to subtract 100 from laborcost itself (rather than laborcost[ h ]).
:[font = input; preserveAspect]
Clear[ f ];
(f = laborcost - 100) // PWSForm
:[font = text; inactive; preserveAspect]
Function f[], defined this way, is a PWS function, and can be used as such.
:[font = input; preserveAspect]
f[ 55 ]
:[font = text; inactive; preserveAspect; endGroup]
When all functions involved are frozen, however, arithmetic results are simplified to produce new PWSf functions.  The resulting function is defined only on the intersection of the domains of the original functions.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (adding frozen functions)
:[font = text; inactive; preserveAspect]
First, we freeze labor cost using the current value (50) for 'double.'
:[font = input; preserveAspect]
(laborcostf = PWSFreeze[ laborcost ]) // PWSForm
:[font = text; inactive; preserveAspect]
We could use Evaluate to lock in the current value of  'double' in the formula for the third domain segment, but it is unnecessary (we will be done with 'laborcostf' before we change 'double').
:[font = text; inactive; preserveAspect]
Now, let us add the cost of benefits ('benefitsf') to the direct labor cost ('laborcostf'):
:[font = input; preserveAspect]
(totalcost = laborcostf + benefitsf) // PWSForm
:[font = text; inactive; preserveAspect; endGroup]
Observe that the result is a single frozen piecewise smooth function, with a formula that changes at 40 hours (beyond which overtime kicks in), 45 hours (beyond which insurance cost increases) and 50 hours (beyond which double-time pay kicks in).
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (squaring a frozen function)
:[font = text; inactive; preserveAspect]
As another illustration, suppose that we want to square the direct labor cost, preparatory to computing a root-mean-square average of it across workers:
:[font = input; preserveAspect]
(laborcostf ^ 2) // PWSForm
:[font = text; inactive; preserveAspect; endGroup; endGroup]
Note that the result is again a PWSf function.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Extensions to Internal Functions
:[font = text; inactive; preserveAspect]
Package PWS` extends several of the kernel functions in Mathematica to operate on piecewise smooth (PWS or PWSf) functions.  ExtendedToPWS contains a list of the functions which have been modified.
:[font = input; preserveAspect; endGroup]
ExtendedToPWS
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Derivatives of Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
Kernel functions D[] and Derivative[] can be applied to piecewise smooth functions to compute their derivatives.  The derivative of a piecewise smooth function is again a piecewise smooth function.  In computing derivatives, we drop isolated domain points (singletons), as the derivative at an isolated point does not exist.  We also change closed domain intervals to open intervals, since the derivative  at an endpoint would (presumably) be a one-sided (directional) derivative.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (D)
:[font = text; inactive; preserveAspect]
To illustrate, we can compute the first derivative of the labor cost function defined earlier.  First, recall its definition:
:[font = input; preserveAspect]
Clear[ double ];
:[font = input; preserveAspect]
laborcost // PWSForm
:[font = text; inactive; preserveAspect]
Now, compute the derivative, using the normal syntax for D[]:
:[font = input; preserveAspect]
(dlaborcost = D[ laborcost[ h ], h ]) // PWSForm
:[font = text; inactive; preserveAspect]
Note that the derivative dlaborcost depends on the symbolic constant double.  Note also that the derivative has exclusively open intervals in its domain.  The labor cost function was piecewise linear, so its first derivative is piecewise constant, with jump discontinuities.  To compute the directional derivatives at one of the points of discontinuity, we can evaluate the derivative infinitesimally above/below the point:
:[font = input; preserveAspect]
double = 50;  (* assign a temporary value to double *)
:[font = input; preserveAspect]
dlaborcost /@ {IB[ 40 ], IA[ 40 ]}
:[font = text; inactive; preserveAspect]
The labor cost function has slope 0 to the left of 40 and 22.5 to the right of 40.
:[font = text; inactive; preserveAspect]
The chain rule works as usual:
:[font = input; preserveAspect]
Clear[ dl, double ];
:[font = input; preserveAspect]
dl[ h_ ] = D[ laborcost[ 3h + 5 ], h ]
:[font = text; inactive; preserveAspect]
To evaluate dl[], we first must assign a value to double.
:[font = input; preserveAspect]
{dl[ 3 ], dl[ 12 ]}
:[font = text; inactive; preserveAspect]
Without assigning a value to double, dl[] can be evaluated only if the transformed argument falls within the first domain interval (whose limits do not depend on double).
:[font = input; preserveAspect]
double = 50;
:[font = input; preserveAspect]
{dl[ 3 ], dl[ 12 ]}
:[font = text; inactive; preserveAspect]
Once double is given a value, dl[] evaluates anywhere, so long as the transformed argument falls within the domain of laborcost.
:[font = text; inactive; preserveAspect]
Finally, suppose we compute the derivative of laborcost when double has a value.
:[font = input; preserveAspect]
Clear[ dl ];
:[font = input; preserveAspect]
dl[ h_ ] = D[ laborcost[ 3h + 5 ], h ]
:[font = text; inactive; preserveAspect; endGroup]
Note that dl[] depends not on the parameter double but on its current value (50).  If we change the value of double later, dl[] will not change.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (Derivative)
:[font = text; inactive; preserveAspect]
The operator Derivative[ n ][] is applied to a PWS or PWSf function (specified without argument), creating another PWS function.
:[font = input; preserveAspect]
benefitsf // PWSForm
:[font = input; preserveAspect]
(db = Derivative[ 1 ][ benefitsf ]) // PWSForm
:[font = input; preserveAspect]
db[ 50 ]
:[font = text; inactive; preserveAspect; endGroup; endGroup]
The only restriction on Derivative is that, since PWS functions take a single argument, partial derivatives are not supported.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Integrals of Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
You can use the kernel function Integrate[] to calculate both definite and indefinite integrals of piecewise smooth functions. The indefinite integral of a piecewise smooth function is another piecewise smooth function of the same type, with the same domains, whose formula on each domain is the antiderivative of the integrand's formula for that domain.  Singleton domains are dropped during integration.  The definite integral of a frozen piecewise smooth function is a number.  Definite integrals of unfrozen piecewise smooth functions are computed by first freezing them.
:[font = text; inactive; preserveAspect]
The only departure from standard Mathematica usage of Integrate[] is that the argument of the piecewise smooth function in the integrand must be the variable of integration, not an expression involving the variable.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (Indefinite Integral)
:[font = text; inactive; preserveAspect]
Without regard to any possible interpretation (or the lack thereof), we will integrate the function laborcost[] defined earlier.
:[font = input; preserveAspect]
Integrate[ laborcost[ h ], h ] // PWSForm
:[font = text; inactive; preserveAspect]
If the integrand is not in the form PWS[ ... ][ x ] or PWSf[ ... ][ x ], where x is the variable of integration, then the integral goes unevaluated.  For instance, consider the following simple expression:
:[font = input; preserveAspect]
Integrate[ laborcost[ 2h ], h ]
:[font = text; inactive; preserveAspect; endGroup]
Note that Integrate[] returned the integrand unchanged.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (Definite Integral)
:[font = text; inactive; preserveAspect]
Recall  our frozen version of the laborcost[] function:
:[font = input; preserveAspect]
laborcostf // PWSForm
:[font = text; inactive; preserveAspect]
We can compute the definite integral from 10 to 60:
:[font = input; preserveAspect]
Integrate[ laborcostf[ h ], {h, 10, 60} ]
:[font = text; inactive; preserveAspect]
If the limits of integration fall outside the domain of the integrand, the integrand is treated as being zero outside its domain.
:[font = input; preserveAspect]
Integrate[ laborcostf[ h ], {h, 10, 65} ]
:[font = text; inactive; preserveAspect]
To integrate an unfrozen function, the package must first freeze it.
:[font = input; preserveAspect]
Clear[ double ];
:[font = input; preserveAspect]
Integrate[ laborcost[ h ], {h, 10, 60} ]
:[font = text; inactive; preserveAspect]
Integrate[] fails because the domain parameter double is symbolic.  If we give it a value, Integrate[] will temporarily freeze the function (without creating a permanent PWSf copy).
:[font = input; preserveAspect]
double = 52; 
Integrate[ laborcost[ h ], {h, 10, 60} ]
:[font = input; preserveAspect; endGroup; endGroup]
Clear[ double ];
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Cumulative Integral
:[font = text; inactive; preserveAspect]
If a piecewise smooth function denotes a rate of some type, you might wish to compute the accumulation of that flow.  If f[] is the rate function, and if x0 is the left-most point in the domain of f[], the accumulation at point x is the integral from x0 to x of f[].  The function PWSAccumulate expresses the accumulation as another frozen piecewise smooth function, having the same domain as f[].  It only works with frozen piecewise smooth functions, since in unfrozen functions the ordering of the domain intervals may be ambiguous.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (incremental quantity discount on purchase)
:[font = text; inactive; preserveAspect]
Suppose that a vendor charges $200 per unit for orders of up to 1,000 units of a particular product, and $150 each for any units ordered in excess of 1,000.  The price function is:
:[font = input; preserveAspect]
(price = 
  PWSFreeze[ PWS[ {{{0, 1000}, 200&}, 
                   {{IA[ 1000 ], Infinity}, 150&}}
             ]
  ]) // PWSForm
:[font = text; inactive; preserveAspect]
The total cost of an order is just
:[font = input; preserveAspect]
PWSAccumulate[ price ] // PWSForm
:[font = input; preserveAspect; endGroup; endGroup]
Clear[ price ];
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Joining Two Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
The Join[] operator can be used to join two piecewise smooth functions.  "Joining" combines the domain lists of the two functions, under the assumption that the lists are disjoint.  If either of the arguments is an unfrozen (PWS) function, the result is an unfrozen function, and Join[] makes no attempt to verify that there is no overlap in the domains.  If both arguments are frozen (PWSf), Join[] freezes the resulting function; should the domains intersect, Join[] detects this during the freezing process and fails with a diagnostic message.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (Joining PWS Functions)
:[font = text; inactive; preserveAspect]
We start by creating two simple PWS functions.
:[font = input; preserveAspect]
Clear[ test1, test2, x1, x2 ];
(test1 = PWS[ {{{0.5, x1}, 2 # &}, {{IA[ x1 ], 1}, 3 # &}}
         ]) // PWSForm
(test2 = PWS[ {{{0, .3}, Sqrt}, {{IA[ .3 ], x2}, 1/# &}}
         ]) // PWSForm
:[font = text; inactive; preserveAspect]
Now we join them:
:[font = input; preserveAspect]
Join[ test1, test2 ] // PWSForm
:[font = text; inactive; preserveAspect; endGroup]
For all domains to be nonempty, we must have 0.3 <= x2 and 0.5 <= x1 <= 1.  Whether the joined function is valid depends on x2; if x2 >= 0.5, then the domains of the first and last segments overlap, and the function is defined ambiguously at points in the intersection.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (Joining PWSf Functions)
:[font = text; inactive; preserveAspect]
Continuing the previous example, let us freeze the original functions and then join them.
:[font = input; preserveAspect]
Clear[ test1f, test2f ];
x1 = 0.7; x2 = 0.6;  (* this will cause an overlap *)
(test1f = PWSFreeze[ test1 ]) // PWSForm
(test2f = PWSFreeze[ test2 ]) // PWSForm
:[font = input; preserveAspect]
Join[ test1f, test2f ]
:[font = text; inactive; preserveAspect]
Freezing fails, due to the overlapping intervals, and an unfrozen PWS function is returned.  Next, we rectify the error.
:[font = input; preserveAspect]
x2 = 0.4;  (* this will avoid an overlap *)
(test2f = PWSFreeze[ test2 ]) // PWSForm
:[font = input; preserveAspect; endGroup; endGroup]
Join[ test1f, test2f ] // PWSForm
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Minima of Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
The Mathematic kernel function FindMinimum is designed to locate a local minimum of a criterion function.  We have extended it to operate on piecewise smooth functions.  There is a slight change in syntax when the argument is a PWS or PWSf function:  the starting point(s) and interval limits must be omitted.  Thus the syntax for a PWS function f[] looks like
:[font = text; inactive; preserveAspect]
FindMinimum[ f[ x ], {x} ]
:[font = text; inactive; preserveAspect]
where x is a dummy variable.
:[font = text; inactive; preserveAspect]
FindMinimum operates in the following way on piecewise smooth functions.  It searches each domain interval separately for local minima.  An isolated point is automatically a local minimum within its domain.  On an interval, FindMinimum counts the left endpoint as a local minimum if the derivative is positive there, and a right endpoint if the derivative is negative there.  In the current incarnation, FindMinimum does *not* check second- or higher-order conditions if the derivative vanishes at an endpoint; it simply ignores the endpoint.  Next, the kernel version of FindMinimum is used to search for an interior minimum in the interval.  Finally, the list of local minima for the various domains is whittled down to those whose function value is within PrecisionGoal of the smallest value encountered.
:[font = text; inactive; preserveAspect]
Because FindMinimum can return multiple local minima for a piecewise smooth function, the result returned is a list of entries, each of which matches the format of FindMinimum's output for an ordinary function.  That is, for a PWS or PWSf function, FindMinimum returns a list like
:[font = text; inactive; preserveAspect]
{{function value, {variable -> value}}...}.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (minimum of "laborcost")
:[font = text; inactive; preserveAspect]
Recall the labor cost function defined earlier:
:[font = input; preserveAspect]
Clear[ double ];
laborcost // PWSForm
:[font = text; inactive; preserveAspect]
By inspection, the minimum is 600, and it occurs throughout the interval [0, 40].  We will attempt to  find this with FindMinimum.
:[font = input; preserveAspect]
FindMinimum[ laborcost[ h ], {h} ]
:[font = text; inactive; preserveAspect]
FindMinimum locates a single interior minimum within the first domain.  The endpoints are not included because the derivative is zero at them.  Since 'double' has not been given a value, FindMinimum cannot process domains in which it appears as an endpoint.  Let us try assigning it a value:
:[font = input; preserveAspect]
double = 50;
FindMinimum[ laborcost[ h ], {h} ]
:[font = text; inactive; preserveAspect; endGroup]
A second local minimum is found (asymptotically at the left endpoint of the second domain interval).
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (minimum of "benefitsf")
:[font = text; inactive; preserveAspect]
We  can apply FindMinimum[] to the frozen function "benefitsf" defined earlier:
:[font = input; preserveAspect]
benefitsf // PWSForm
:[font = input; preserveAspect]
FindMinimum[ benefitsf[ h ], {h} ]
:[font = text; inactive; preserveAspect; endGroup]
FindMinimum locates an interior minimum in the first domain interval, where the function is constant.  It cannot process the second interval, however, because the upper limit is Infinity, not a proper number.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (multiple minima)
:[font = text; inactive; preserveAspect]
We next construct a function with multiple local minima.
:[font = input; preserveAspect]
(testf = 
  PWS[ {{{0, 2}, 5 + (#-1)^2&},
        {{IA[ 2 ], IB[ 4 ]}, 5.5 + 1/#&},
        {{4}, # + 1 &},
        {{IA[ 4 ], 6}, 3 + Sqrt[ # ] &}} ]
) // PWSForm
:[font = text; inactive; preserveAspect]
Our test function has an interior local minimum on the first interval (at 1, with function value 5); is decaying on the second interval (approaching a minimum with value 5.75 near 4); takes the value 5 at the isolated point 4; and is increasing on the final interval (with value approaching 5 at the left end).  Applying FindMinimum:
:[font = input; preserveAspect]
Clear[ x ];
FindMinimum[ testf[ x ], {x} ]
:[font = text; inactive; preserveAspect; endGroup; endGroup]
FindMinimum locates the value 5 at the interior minimum x = 1 and at the isolated point x = 4, and the asymptotic value 5 as x approaches 4 from above.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Min and Max of Frozen Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
If f[] and g[] are frozen piecewise smooth functions, Min[f, g] and Max[f, g] are also frozen piecewise smooth functions, where the operator (Min or Max) is applied segment by segment across the union of the domains of f[] and g[].  At points belonging to the domain of only one of the argument functions, both Min and Max revert to the value of the one function defined there.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (Min)
:[font = text; inactive; preserveAspect]
As an illustration, we apply the Min[] operator to the frozen functions laborcostf and benefitsf defined above.
:[font = input; preserveAspect]
laborcostf // PWSForm
:[font = input; preserveAspect]
benefitsf // PWSForm
:[font = input; preserveAspect]
Min[ laborcostf, benefitsf ] // PWSForm
:[font = text; inactive; preserveAspect; endGroup; endGroup]
Note the final interval in the result, where laborcostf is undefined and the minimum is just the value of benefitsf.
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Plotting Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
It  is not possible to plot a piecewise smooth function with symbolic constants in its domain, since the plotting routine must be able to assign a numeric value to the abscissa of each plot point.  For a function with entirely numeric domain specifications, though, plotting is possible.
:[font = text; inactive; preserveAspect]
The standard kernel function Plot[], without modification, can plot a piecewise smooth function whose domain is entirely numeric, but it has certain shortcomings.  If the function is discontinuous as  it shifts from one domain to the next, Plot[] may try to connect contiguous pieces with line segments.  It also may struggle if it encounters an infinitesimally adjusted point.  Moreover, Plot[] will plot every segment of a piecewise smooth function using the same style.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Changes to Plot
:[font = text; inactive; preserveAspect]
We have enhanced the operation of Plot[] on piecewise smooth functions.  When Plot[] encounters an unfrozen function, it will attempt to freeze it.  On a frozen function, Plot[] behaves as normal other than the following changes.
:[font = text; inactive; preserveAspect]
The argument to Plot[] must be a PWS or PWSf function evaluated at the plot variable.
:[font = text; inactive; preserveAspect]
Expressions involving the plot variable will cause Plot[] to default to its standard behavior, losing the enhancements.  For instance, given a PWS function f[],
:[font = text; inactive; preserveAspect]
Plot[ f[ x ], {x, xmin, xmax}, options ]
:[font = text; inactive; preserveAspect]
will use the enhancements to Plot[], but
:[font = text; inactive; preserveAspect]
Plot[ f[ x + 0 ], {x, xmin, xmax}, options ]
:[font = text; inactive; preserveAspect]
will use the unenhanced kernel version of Plot[].
:[font = text; inactive; preserveAspect]
If the optional parameter PlotStyle is specified, the listed plot styles are applied cyclically to each segment of the plot. 
:[font = text; inactive; preserveAspect]
If a list of PWS or PWSf functions is to be plotted in one command, the use of PlotStyle changes.
:[font = text; inactive; preserveAspect]
If PlotStyle is specified as a single graphics primitive or a single list of primitives, then that style is applied to each segment of each function.  If PlotStyle is assigned a list of lists, then all functions are plotted in the same style, with the member lists of PlotStyle assigned cyclically to each segment of every function.  Finally, if PlotStyle is assigned a list of lists of lists, then the first level lists are assigned cyclically to the functions to be plotted, and for each function the sublists of its PlotStyle are applied cyclically to the segments.
:[font = text; inactive; preserveAspect]
Plot[] has a new option, EndPoints, valid only when plotting PWS or PWSf functions.
:[font = text; inactive; preserveAspect; endGroup]
EndPoints can be assigned any valid graphics primitive or list of graphics primitives.  If EndPoints is used, the assigned primitives are used to plot the left and right endpoints of each domain (along with all singletons).  If the default value {} is used, domain endpoints will be plotted as normal points, indistinguishable from other plot points.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (laborcost)
:[font = text; inactive; preserveAspect]
We begin by plotting laborcost, defined earlier.
:[font = input; preserveAspect]
Clear[ double ];
laborcost // PWSForm
:[font = input; preserveAspect]
Plot[ laborcost[ h ], {h, 0, 60},
      PlotRange -> {All, {500, 1200}} ];
:[font = text; inactive; preserveAspect]
After various error messages, Plot[] fails, because 'double' was not assigned a numeric value. We remedy this by assigning 'double' a value.
:[font = input; preserveAspect]
double = 50;
Plot[ laborcost[ h ], {h, 0, 60}, 
      PlotRange -> {All, {500, 1200}} ];
:[font = text; inactive; preserveAspect]
We can dramatize the change in domains by assigning rotating plot styles to the segments.
:[font = input; preserveAspect]
Plot[ laborcost[ h ], {h, 0, 60}, 
      PlotRange -> {All, {500, 1200}},
      PlotStyle -> 
        {{Hue[ 0 ]}, {Hue[ 0.6 ], Dashing[ {0.02} ]}}
];
:[font = text; inactive; preserveAspect]
Observe that the first and third segments have the same style, different from the second segment.  With or without PlotStyle, we can use EndPoints to emphasize the breaks in the domains.
:[font = input; preserveAspect; endGroup]
Plot[ laborcost[ h ], {h, 0, 60}, 
      PlotRange -> {All, {500, 1200}},
      PlotStyle -> 
        {{Hue[ 0 ]}, {Hue[ 0.6 ], Dashing[ {0.02} ]}},
      EndPoints -> {Hue[ 0.8 ], PointSize[ 0.02 ]}
];
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (laborcost and benefits)
:[font = text; inactive; preserveAspect]
To illustrate superposition of plots, we will plot laborcost and benefits on the same axes.
:[font = input; preserveAspect]
inslim = 45;
benefits // PWSForm
:[font = input; preserveAspect]
Plot[ {laborcost[ h ], benefits[ h ]}, {h, 0, 60},
      PlotStyle -> 
        {{Hue[ 0 ]}, {Hue[ 0.8 ], Dashing[ {0.02} ]}},
      EndPoints -> PointSize[ 0.02 ]
];
:[font = text; inactive; preserveAspect]
Observe that the PlotStyle list (solid red line, dashed violet line) is applied cyclically to the segments of each curve.  To specify separate styles for each curve, we enclose the style lists in another set of braces:
:[font = input; preserveAspect; endGroup; endGroup]
Plot[ {laborcost[ h ], benefits[ h ]}, {h, 0, 60},
      PlotStyle -> 
        (* style for laborcost *)
        {{{Hue[ 0 ]}, {Hue[ 0.8 ], Dashing[ {0.02} ]}},
        (* style for benefits *)
         {{Hue[ 0.6 ], Dashing[ {0.02, 0.01, 0.02} ]},
          {Thickness[ 0.01 ]}}},
      EndPoints -> PointSize[ 0.02 ]
];
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
Distributing Operators over Piecewise Smooth Functions
:[font = text; inactive; preserveAspect]
Typically, unary operators should distribute across piecewise smooth functions.  For example, if f[] is a piecewise smooth function, Abs[f] is another piecewise smooth function, with the same domains, such that on each domain the function to be applied is the composition of Abs[] and the relevant component function of f[].
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Automatic Distribution
:[font = text; inactive; preserveAspect]
DistributeOverPWS lists those operators which are automatically distributed over PWS and PWSf functions.
:[font = input; preserveAspect]
DistributeOverPWS
:[font = text; inactive; preserveAspect]
For example, we might want to take the logarithm of the labor cost function:
:[font = input; preserveAspect]
laborcost // PWSForm
:[font = input; preserveAspect]
Log[ laborcost ] // PWSForm
:[font = text; inactive; preserveAspect]
Note that the logarithm of the PWS function laborcost is a PWS function, whereas the logarithm of laborcost[ h ], for some argument h, is the logarithm of a number.
:[font = input; preserveAspect; endGroup]
Clear[ h ]; Log[ laborcost[ h ] ]
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Manual Distribution
:[font = text; inactive; preserveAspect]
If you want a function not on the list DistributeOverPWS to distribute across piecewise smooth functions, you have two approaches.  To make distribution automatic across all piecewise smooth functions, unprotect DistributeOverPWS and add the function to the list.  To force distribution selectively, use the Distribute[] function, specifying either PWS or PWSf (interchangeably) as the second operand.
:[font = text; inactive; preserveAspect]
As an example, we will convert labor costs (scaled to the interval [0, 1]) to colors using Hue.  First, we establish the range of laborcost values.
:[font = input; preserveAspect]
double = 50; {laborcost[ 0 ], laborcost[ 60 ]}
:[font = text; inactive; preserveAspect]
Now, we distribute Hue[] across the scaled cost function:
:[font = input; preserveAspect; endGroup; endGroup]
Distribute[ Hue[ (laborcost - 600)/525 ], PWS ] //
  PWSForm
:[font = subsection; inactive; Cclosed; preserveAspect; startGroup]
General Binary Operators
:[font = text; inactive; preserveAspect]
Function PWSOperate[] provides a mechanism for extending any binary operator to frozen piecewise smooth functions.  The first three arguments (frozen piecewise smooth functions f[] and g[] and binary operator op[]) are required.  PWSOperate[f, g, op] creates a frozen piecewise smooth function h[] whose domain is the intersection of the domains of f[] and g[], such that for any x in the domain intersection, h[x] = op[f[x], g[x]].  Since PWSOperate must be able to align the domains of f[] and g[], both functions must be frozen (no symbolic endpoints).
:[font = text; inactive; preserveAspect]
PWSOperate allows two optional arguments, which specify default functions used to replace f[] and g[] outside their respective domains.  Using these optional arguments, the resulting function h[] is defined on the union, rather than intersection, of the domains of f[] and g[].  If a single optional argument is given, it replaces both f[] and g[] where they are undefined.  If two arguments are given, the first replaces f[] and the second replaces g[].  If either optional argument is Indeterminate&, h[] is undefined outside the domain of the corresponding function f[] or g[].  Note that the optional arguments must be functions, not constants.
:[font = subsubsection; inactive; Cclosed; preserveAspect; startGroup]
Example (Beta function)
:[font = text; inactive; preserveAspect]
To illustrate the use of PWSOperate, suppose that the arguments a and b of the Beta function are parametrized by a single parameter t in a piecewise smooth manner.  We want to define a piecewise smooth function f[] such that f[t] = Beta[a[t], b[t]] wherever a and b are both defined.  To make things interesting, we will define a[] and b[] on somewhat different domains, and specify that f[t] be undefined if a[t] is undefined but that f[t] = Beta[a[t], 1] wherever b[t] is undefined.
:[font = text; inactive; preserveAspect]
First, we make up functions a[] and b[].
:[font = input; preserveAspect]
(a = PWSFreeze[ PWS[ {{{0, 1}, Identity},
                     {{2, 3}, 0.5 # &}} ] ]) // PWSForm
:[font = input; preserveAspect]
(b = 
  PWSFreeze[ 
    PWS[ {{{0, .5}, Identity},
          {{1.5, 2.5}, # + 1 &},
          {{IA[ 2.5 ], 3.5}, # + 2&}} ] ]) // PWSForm
:[font = text; inactive; preserveAspect]
Now we construct the parametrized Beta function.  To restrict the domain of f to the domain of a, we set the first optional parameter to Indeterminate.  We make the second optional parameter 1.& (not just 1.) to cause b[t] to default to 1 when undefined.
:[font = input; preserveAspect]
(f = PWSOperate[ a, b, Beta, Indeterminate, 1. & ]) //
  PWSForm
:[font = text; inactive; preserveAspect]
On the interval [0, 0.5], a[t] = b[t] = t and so f[t] = Beta[t, t].  On (0.5, 1], a[t] = t and b[t] is undefined (defaulting to 1), so f[t] = Beta[t, 1] = Gamma[t]/Gamma[t+1] = 1/t.  On (1, 2), a[t] is undefined and hence so is f[t], even though b[t] is defined for t in [1.5, 2).  For t in [2, 2.5], 
a[t] = .5t and b[t] = t+1,  so f[t] = Beta[.5t, t+1].  For t in (2.5, 3], b[t] changes to t+2 and f[t] becomes Beta[.5t, t+2].
:[font = input; preserveAspect]
f[2]
:[font = text; inactive; preserveAspect; endGroup; endGroup; endGroup]
f[2] = Beta[1, 3] = Gamma[1]Gamma[3]/Gamma[4] = 1/3.
:[font = section; inactive; Cclosed; preserveAspect; startGroup]
Epilog
:[font = text; inactive; preserveAspect]
Before closing the notebook, we can clear out any variables we created and free up their memory.
:[font = input; preserveAspect]
If[ sp, On[ General::spell ] ];    (* reset warning *)
If[ sp1, On[ General::spell1 ] ];  (* messages      *)
:[font = input; preserveAspect]
End[];  (* close the context *)
:[font = input; preserveAspect; endGroup; endGroup]
Remove[ "PWSWalkThrough`*" ]  (* zap any variables *)
^*)
